
#ifndef COOKTORRENCE_H_INCLUDED
#define COOKTORRENCE_H_INCLUDED

#include <texturedata.h>

class CookTorrence
{
public:
    CookTorrence( double diffr, double diffg, double diffb,
                  double specr, double specg, double specb,
                  double kd, double ks, double m, unsigned int size );
    ~CookTorrence( void );

    /**
     * Takes parameters ( v.h, n.h ).
     */
    TextureData *getTexture1( void ) const { return f1; }

    /**
     * Takes parameters ( n.l, n.v ).
     */
    TextureData *getTexture2( void ) const { return f2; }

    /**
     * Rebuilds the textures with new parameters.
     */
    void rebuild( double diffr, double diffg, double diffb,
                  double specr, double specg, double specb,
                  double kd, double ks, double m, unsigned int size );

private:
    TextureData *f1;
    TextureData *f2;
};

#endif // COOKTORRENCE_H_INCLUDED
