
#include <math.h>
#include <stdio.h>
#include "pngoutput.h"
#include "phong.h"

Phong::Phong( double n, unsigned int s )
{
    unsigned int i, j;
    unsigned char *buf;

    size = s;
    pixels = new unsigned char[ s * s * 4 ];
    buf = pixels;

    pngoutput_t *pngoutput = pngoutput_new( "phong.png", size, size, 0.45 );
    for( i = 0; i < size; i++ ) {
        for( j = 0; j < size; j++ ) {
            double nh = (double) j / (double) ( size - 1 );
            double nk = (double) i / (double) ( size - 1 );

            nh = ( nh * 2.0 ) - 1.0;
            nk = ( nk * 2.0 ) - 1.0;

            double result = pow( nh, n );// / nk;

            if( result >  1.0 ) result =  1.0;
            if( result < -1.0 ) result = -1.0;

            *buf++ = (unsigned char) ( ( result * 255.0 ) + 0.5 );
            *buf++ = (unsigned char) ( ( result * 255.0 ) + 0.5 );
            *buf++ = (unsigned char) ( ( result * 255.0 ) + 0.5 );
            *buf++ = 0xff;
        }
        pngoutput_scanline( pngoutput, pixels + (i * s * 4) );
    }
    pngoutput_delete( pngoutput );

    success = setupTexture( pixels );
}

Phong::~Phong( void )
{
    delete [] pixels;
}

