
#include <stdlib.h>
#include <string.h>
#include "pnginput.h"
#include "pngtexture.h"

PNGTexture::PNGTexture( const char *filename )
{
    pnginput_t *pnginput = pnginput_new( filename );
    unsigned int i, width, height;
    int rowbytes;

    if( !pnginput ) return;

    width = pnginput_get_width( pnginput );
    height = pnginput_get_height( pnginput );
    rowbytes = width * 4;
    pixels = new unsigned char[ rowbytes * height ];
    size = width;
    clamp = false;

    for( i = 0; i < height; i++ ) {
        unsigned char *buf = pixels + (i * rowbytes);
        unsigned char *scanline = pnginput_get_scanline( pnginput, i );
        unsigned int j;

        for( j = 0; j < width; j++ ) {
            buf[ 0 ] = scanline[ 0 ];
            buf[ 1 ] = scanline[ 1 ];
            buf[ 2 ] = scanline[ 2 ];
            buf[ 3 ] = buf[ 0 ] ? 0xff : 0x00;
            buf += 4; scanline += 3;
        }
    }

    success = setupTexture( pixels );
}

PNGTexture::~PNGTexture( void )
{
    delete [] pixels;
}

