
#ifndef POINTLIGHT_H_INCLUDED
#define POINTLIGHT_H_INCLUDED

#include <primitive.h>

class PointLight : public Primitive
{
public:
    explicit PointLight( const Point3 &ipos = Point3::origin ) : pos( ipos ) {}
    ~PointLight( void ) {}

    virtual bool isPointLight( void ) const { return true; }

    BoundingBox getBoundingBox( void ) const
    {
        BoundingBox b;
        b.minx = b.maxx = pos.getX();
        b.miny = b.maxy = pos.getY();
        b.minz = b.maxz = pos.getZ();
        return b;
    }

    PrimitiveList foldModel( const Matrix4x4 &xform ) const
    {
        PrimitiveList pl;
        PointLight *p = new PointLight( multiplyPointByMatrix( xform, pos ) );
        p->setMaterial( getMaterial() );
        pl.push_back( p );
        return pl;
    }

    VertexList foldToVerticies( const Matrix4x4 &xform ) const
    {
        VertexList v;
        return v;
    }

    Point3 getRandomLightPosition( const Point3 &closest,
                                   double *probability ) const
    {
        *probability = 1.0;
        return pos;
    }

    bool closestIntersect( const Point3 &origin, const Vector3 &dir,
                           double *t, Vector3 *normal, Material **mat ) const
    {
        return false;
    }

private:
    Point3 pos;
};

#endif // POINTLIGHT_H_INCLUDED
