
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <GL/glu.h>
#include "texturedata.h"

TextureData::TextureData( void )
    : success( false ), clamp( true )
{
}

TextureData::~TextureData( void )
{
    glDeleteTextures( 1, &texid );
    assert( glGetError() == GL_NO_ERROR );
}

bool TextureData::setupTexture( unsigned char *data )
{
    glGenTextures( 1, &texid );
    assert( glGetError() == GL_NO_ERROR );
    glBindTexture( GL_TEXTURE_2D, texid );
    assert( glGetError() == GL_NO_ERROR );
    glTexImage2D( GL_TEXTURE_2D, 0, GL_RGBA, size, size, 0,
                  GL_RGBA, GL_UNSIGNED_BYTE, data );
    assert( glGetError() == GL_NO_ERROR );
    gluBuild2DMipmaps( GL_TEXTURE_2D, GL_RGBA, size, size,
                       GL_RGBA, GL_UNSIGNED_BYTE, data );
    return true;
}

