
#ifndef TEXTUREDATA_H_INCLUDED
#define TEXTUREDATA_H_INCLUDED

#include <assert.h>
#include <GL/gl.h>

class TextureData
{
public:
    TextureData( void );
    virtual ~TextureData( void );

    bool wasSuccessful( void ) const { return success; }
    unsigned int getSize( void ) const { return size; }
    void bindTexture( void ) const
    {
        glBindTexture( GL_TEXTURE_2D, texid );
        assert( glGetError() == GL_NO_ERROR );
        glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S,
                         clamp ? GL_CLAMP : GL_REPEAT );
        glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T,
                         clamp ? GL_CLAMP : GL_REPEAT );
        glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
        glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
                                        GL_NEAREST_MIPMAP_LINEAR );
    }

protected:
    unsigned int size;
    bool success;
    bool clamp;

    bool setupTexture( unsigned char *data );

private: 
    GLuint texid;
};

#endif // TEXTUREDATA_H_INCLUDED
